// Задача "Палиндромность-4"
// 4-я личная Интернет-олимпиада сезона 2008-2009
// Автор задачи: Максим Буздалов, buzdalov@rain.ifmo.ru
// Автор условия: Владимир Ульянцев, ulyantsev@rain.ifmo.ru
// Автор решения: Максим Буздалов, buzdalov@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class paly4_mb {
    static StringBuilder go(int[] values) {
        int lastOdd = -1, oddCount = 0;
        boolean allZero = true;
        for (int i = 0; i < values.length; ++i) {
            if (values[i] % 2 == 1) {
                ++oddCount;
                lastOdd = i;
            }
            if (values[i] > 0) {
                allZero = false;
            }
        }
        if (allZero) {
            return new StringBuilder();
        }
        if (oddCount == 0) {
            for (int i = 0; i < values.length; ++i) {
                values[i] /= 2;
            }
            StringBuilder rec = go(values);
            for (int i = rec.length() - 1; i >= 0; --i) {
                rec.append(rec.charAt(i));
            }
            return rec;
        } else if (oddCount == 1) {
            values[lastOdd] -= 1;
            for (int i = 0; i < values.length; ++i) {
                values[i] /= 2;
            }
            StringBuilder rec = go(values);
            rec.append((char) (lastOdd + 'a'));
            for (int i = rec.length() - 2; i >= 0; --i) {
                rec.append(rec.charAt(i));
            }
            return rec;
        } else {
            StringBuilder rv = new StringBuilder();
            for (int i = 0; i < 26; ++i) {
                char c = (char) (i + 'a');
                for (int j = 0; j < values[i]; ++j) {
                    rv.append(c);
                }
            }
            return rv;
        }
    }

    public static void main(String[] args) throws IOException {
        Scanner in = new Scanner(new File("paly4.in"));
        int[] values = new int[26];
        int sum = 0;
        for (int i = 0; i < 26; ++i) {
            sum += values[i] = in.nextInt();
            if (values[i] < 0 || values[i] > 1000000) {
                throw new AssertionError("c_i is out of bounds");
            }
            if (sum > 1000000) {
                throw new AssertionError("sum exceeds limit");
            }
        }
        in.close();

        String rv = go(values).toString();

        PrintWriter out = new PrintWriter("paly4.out");
        out.println(rv);
        out.close();
    }
}
